package com.umeng.crash.plugin;

import android.content.Context;
import android.os.Bundle;

import androidx.annotation.NonNull;

import com.umeng.analytics.MobclickAgent;
import com.umeng.commonsdk.UMConfigure;
import com.umeng.commonsdk.listener.OnGetOaidListener;
import com.umeng.umcrash.BuildConfig;
import com.umeng.umcrash.UMCrash;

import io.flutter.embedding.engine.plugins.FlutterPlugin;
import io.flutter.plugin.common.MethodCall;
import io.flutter.plugin.common.MethodChannel;
import io.flutter.plugin.common.MethodChannel.MethodCallHandler;
import io.flutter.plugin.common.MethodChannel.Result;


public class UmengCrashPlugin implements FlutterPlugin, MethodCallHandler {

  private MethodChannel channel;

  Context mContext;

  @Override
  public void onAttachedToEngine(@NonNull FlutterPluginBinding flutterPluginBinding) {
    mContext = flutterPluginBinding.getApplicationContext();
    channel = new MethodChannel(flutterPluginBinding.getBinaryMessenger(), "umeng.crash.plugin");
    channel.setMethodCallHandler(this);
  }

  @Override
  public void onMethodCall(@NonNull MethodCall call,final @NonNull Result result) {
    if("preInit".equals(call.method)){
      //设置LOG开关
      UMConfigure.setLogEnabled(BuildConfig.DEBUG);
      //预初始化
      String appKey = call.argument("appKey");
      String channel = call.argument("channel");
      UMConfigure.preInit(mContext,appKey,channel);
      result.success(true);
    }else if("init".equals(call.method)){
      String appKey = call.argument("appKey");
      String channel = call.argument("channel");
      String pushSecret = call.argument("pushSecret");
      int deviceType = UMConfigure.DEVICE_TYPE_PHONE;
      UMConfigure.init(mContext,appKey,channel,deviceType,pushSecret);
      result.success(true);
    }else if("setAppVersion".equals(call.method)){
      String version = call.argument("version");//"1.0.0"
      String subVersion = call.argument("subVersion");//"release"
      String buildId = call.argument("buildId");//"0001"
      UMCrash.setAppVersion(version,subVersion,buildId);
      result.success(true);
    }/*else if("initConfig".equals(call.method)){
      Bundle bundle = new Bundle();
      bundle.putBoolean(UMCrash.KEY_ENABLE_CRASH_JAVA, true);
      bundle.putBoolean(UMCrash.KEY_ENABLE_CRASH_NATIVE, true);
      bundle.putBoolean(UMCrash.KEY_ENABLE_CRASH_UNEXP, true);
      bundle.putBoolean(UMCrash.KEY_ENABLE_ANR, true);
      bundle.putBoolean(UMCrash.KEY_ENABLE_PA, true);
      bundle.putBoolean(UMCrash.KEY_ENABLE_LAUNCH, true);
      bundle.putBoolean(UMCrash.KEY_ENABLE_MEM, true);
      UMCrash.initConfig(bundle);
    }*/else if("generateCustomLog".equals(call.method)){//自定义异常接口
      String e = call.argument("e");
      String type = call.argument("type");
      UMCrash.generateCustomLog(e,type);
      result.success(true);
    }else if("onKillProcess".equals(call.method)){
      MobclickAgent.onKillProcess(mContext);
    }else if("getOaid".equals(call.method)){
      UMConfigure.getOaid(mContext,new OnGetOaidListener() {
        @Override
        public void onGetOaid(String oaid) {
          result.success(oaid);;
        }});
    }else if (call.method.equals("getPlatformVersion")) {
      result.success("Android " + android.os.Build.VERSION.RELEASE);
    } else {
      result.notImplemented();
    }
  }

  @Override
  public void onDetachedFromEngine(@NonNull FlutterPluginBinding binding) {
    channel.setMethodCallHandler(null);
  }
}
