#import "UmengCrashPlugin.h"
#import <UMCommon/UMCommon.h>
#import <UMAPM/UMCrashConfigure.h>
#import <UMAPM/UMCrashConfigure.h>

@implementation UmengCrashPlugin
+ (void)registerWithRegistrar:(NSObject<FlutterPluginRegistrar>*)registrar {
  FlutterMethodChannel* channel = [FlutterMethodChannel
      methodChannelWithName:@"umeng.crash.plugin"
            binaryMessenger:[registrar messenger]];
  UmengCrashPlugin* instance = [[UmengCrashPlugin alloc] init];
  [registrar addMethodCallDelegate:instance channel:channel];
}

- (void)handleMethodCall:(FlutterMethodCall*)call result:(FlutterResult)result {
    if([@"preInit" isEqualToString:call.method]){
        
    }else if([@"init" isEqualToString:call.method]){
        NSString *appKey = call.arguments[@"appKey"];
        NSString *channel = call.arguments[@"channel"];
        [UMConfigure initWithAppkey:appKey channel:channel];
        result(@(YES));
    }else if([@"setAppVersion" isEqualToString:call.method]){
        NSString *version = call.arguments[@"version"];
        NSString *subVersion = call.arguments[@"subVersion"];
        //[UMCrashConfigure setAppVersion:version buildVersion:subVersion];
        result(@(YES));
    }else if([@"generateCustomLog" isEqualToString:call.method]){
        NSString *e = call.arguments[@"e"];
        NSString *type = call.arguments[@"type"];
        NSLog(@"%@==>%@",type,e);
        result(@(YES));
    }else if([@"onKillProcess" isEqualToString:call.method]){
        
        result(@(YES));
    }else if([@"getOaid" isEqualToString: call.method]){
        NSString *umengZID = [UMConfigure getUmengZID];
        result(umengZID);
    }else if ([@"getPlatformVersion" isEqualToString:call.method]) {
        result([@"iOS " stringByAppendingString:[[UIDevice currentDevice] systemVersion]]);
    } else {
        result(FlutterMethodNotImplemented);
    }
}

@end
